var em = window.opener.em;
var ball = []; 
var star = [];
function onLoad(){
  try {
    document.title = em.addon().name+' - '+document.title;
    document.getElementById("emButtonSave").setAttribute('disabled', true);
    var nextFri = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate());
    while (nextFri.getDay()!=5) nextFri.setTime(nextFri.getTime()+86400000);
    document.getElementById("date-picker").dateValue = nextFri;
    document.getElementById("emButtonResetBalls").setAttribute('disabled', true);
    document.getElementById("emButtonResetStars").setAttribute('disabled', true);
    document.getElementById("ticket-cost-symbol").setAttribute('value', em.prefs.getCharPref('money.symbol'));
    if("arguments" in window && window.arguments.length > 0) {
      if (typeof window.arguments[0].ticket=='object') {
        var r = window.arguments[0].ticket;
        document.title = em.addon().name+' - Edit Ticket #'+r.id;
        document.getElementById("add-day").hidden = true;
        document.getElementById("remove-day").hidden = true;
        document.getElementById("date-picker").dateValue = new Date(r.date);
        document.getElementById('ticket-cost').value = r.cost;
        var bs = [r.ball.match(/\d+/g),r.star.match(/\d+/g)];
        for(var j=0;j<bs.length;j++)
          for(var jj=0;jj<bs[j].length;jj++)
            onTicket(j, parseInt(bs[j][jj]), true);
      }
    }
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug11:'); }
}
function autoEdit(block) {
  if("arguments" in window && window.arguments.length > 0 && typeof window.arguments[0].ticket=='object') {
    doCleanDays(); if (!block) addDay();
  }
}
function onTicket(t,n, edit){
  try {
    var ts = !t?'ball':'star';
    var tm = !t?10:2;
    var el = document.getElementById(ts+'-'+n);
    if (edit) el.checked = true;
    if (el.checked) {
      if (window[ts].length==tm) {
        el.checked = false;
        return;
      }
      window[ts].push(n);
    } else window[ts].splice(window[ts].indexOf(n), 1);
    window[ts].sort(function(a,b){return parseInt(a)-parseInt(b)});
    el.setAttribute('label', el.checked?'':n);
    el.setAttribute('class', el.checked?'emBL':'');
    el.setAttribute('image', el.checked?'chrome://euromillions/skin/n/'+(t?'e':'')+(n<10?'0':'')+n+'.'+'gif':'');
    buildDescription();
    autoEdit(allowPrepare());
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug1:'); }
}
function buildDescription() {
  try {
    document.getElementById('emHeader').setAttribute('description', 'Balls: [ '+(ball.length?ball.join(' - '):'none')+' ]     Stars: [ '+(star.length?star.join(' - '):'none')+' ]');
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug10:'); }
}
function allowSave() {
  try {
    var l = buildSave();
    document.getElementById("emButtonSave").setAttribute('disabled', (l.firstChild.getAttribute('id')=='dummy-listitem'));
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug9:'); }
}
function buildSave(saving) {
  try {
    var l = document.getElementById('days-list');
    var count = l.getRowCount();
    if (count && l.firstChild.getAttribute('id')=='dummy-listitem') --count;
    document.getElementById("emButtonSave").setAttribute('label', 'Sav'+(saving?'ing':'e')+(count?' '+count+' Ticket'+(count>1?'s':''):'')+(saving?'..':''));
    return l;
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug8:'); }
}
function allowPrepare() {
  try {
    var block = (ball.length<5 || star.length<2);
    document.getElementById('date-picker').setAttribute('disabled', block);
    document.getElementById("add-day").setAttribute('disabled', block);
    document.getElementById("emButtonResetBalls").setAttribute('disabled', (ball.length==0));
    document.getElementById("emButtonResetStars").setAttribute('disabled', (star.length==0));
    return block;
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug7:'); }
}
function doClean(t){
  try {
    var ts = !t?'ball':'star';
    var i = 0;
    var el = document.getElementById(ts+'-'+(++i));
    while (el) {
      el.checked = false;
      el.setAttribute('label', el.getAttribute('id').substr(el.getAttribute('id').indexOf('-')+1));
      el.setAttribute('image', '');
      el.setAttribute('class', '');
      el = document.getElementById(ts+'-'+(++i));
    }
    window[ts] = [];
    buildDescription();
    allowPrepare();
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug2:'); }
}
function doCleanDays() {
  try {
    var l = em.clean('days-list', document);
    var d = em.elc('listitem', document);
    em.attr(d, 'label', 'You must insert at least one day here..');
    em.attr(d, 'id', 'dummy-listitem');
    em.attr(d, 'disabled', true);
    em.add(l, d);
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug3:'); }
}
function addDay() {
  try {
    var day = document.getElementById('date-picker');
    var label = (day.date<10?'0':'')+day.date+'/'+((day.month+1)<10?'0':'')+(day.month+1)+'/'+day.year;
    if (day.dateValue.getDay()!=5) {
      em.alert(label+' is not friday.', document.getElementById('emAddTicket').getAttribute('title'), window);
      return;
    }
    var l = document.getElementById('days-list');
    if (document.getElementById('dummy-listitem')) l.removeChild(l.firstChild);
    var d = em.elc('listitem', document);
    var cost = parseFloat(document.getElementById('ticket-cost').value).toFixed(2);
    document.getElementById('ticket-cost').value = cost;
    em.attr(d, 'label', label+' ('+cost+em.prefs.getCharPref('money.symbol')+')  '+ball.join(',')+'*'+star.join(',')+'');
    em.attr(d, 'date', new Date(day.year, day.month, day.date).getTime());
    em.attr(d, 'ball', ball.join(';'));
    em.attr(d, 'star', star.join(';'));
    em.attr(d, 'cost', cost);
    em.add(l, d);
    allowSave();
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug14:'); }
}
function removeDay() {
  try {
    if (document.getElementById('days-list').firstChild.getAttribute('id')!='dummy-listitem')
      document.getElementById('days-list').removeChild(document.getElementById('days-list').selectedItem);
    document.getElementById('remove-day').setAttribute('disabled', true);
    if (!document.getElementById('days-list').firstChild) doCleanDays();
    else document.getElementById('days-list').selectedItem = document.getElementById('days-list').firstChild;
    allowSave();
  } catch(e) { if (em.DEBUG) em.alert(e, 'emBug6:'); }
}
var timer;
function doSave(i){
  try {
    var dl = document.getElementById('days-list');
    if (dl.firstChild) {
      var id = false;
      if ("arguments" in window && window.arguments.length > 0 && typeof window.arguments[0].ticket=='object')
        id = window.arguments[0].ticket.id;
      var t = dl.firstChild;
      em.sql.query({
        sqlitem:'ticket',
        sqlfunc:id?'update':'insert',
        date:parseInt(t.getAttribute('date')),
        ball:t.getAttribute('ball'),
        star:t.getAttribute('star'),
        cost:parseFloat(t.getAttribute('cost')).toFixed(2),
        prize:'pending',
        id:id
      });
      dl.removeChild(dl.firstChild);
      buildSave(true);
      if (!i) i = 0;
      var event = { notify: function(timer) { doSave(++i); } };
      timer = em.CCIN('@mozilla.org/timer;1', 'nsITimer');
      timer.initWithCallback(event, 1, em.CI('nsITimer').TYPE_ONE_SHOT);
      return;
    }
    em.alert(i+' Ticket'+(i>1?'s were':' was')+' saved.', window.title, window);
    doCleanDays();
    doClean(0);
    doClean(1);
    buildSave();
    if("arguments" in window && window.arguments.length > 0) {
      if (typeof window.arguments[0].cbSave=='function') window.arguments[0].cbSave();
      if (typeof window.arguments[0].ticket=='object') window.close();
    }
 } catch(e) { if (em.DEBUG) em.alert(e, 'emBug5:'); }
}