var em = window.opener.em;
//http://omnipotent.net/jquery.sparkline/#docs
em.stats = {
  onLoad:function(){
    em.stats.buildYears();
    em.el('emMode', document).selectedIndex = 0;
  },
  buildYears:function(){
    var y = 0;
    for(var i=(new Date()).getFullYear();i>=2004;i--) {
      var c = em.elc('checkbox');
      em.attr(c, 'id', 'emYear'+i);
      em.attr(c, 'label', i);
      em.attr(c, 'checked', 'true');
      em.attr(c, 'oncommand', 'em.stats.changeSort();');
      em.add(em.el('emYears'+(y?'1':'0'), document), c);
      y = !y;
    }
  },
  load:function(){
    try {
      em.stats.data = {ball:[],star:[]};
      var data = [];
      var t = em.sql.query({
        sqlitem:'menuItem',
        sqlfunc:'selectOfficial',
        max:-1
      });
      if (!t.success || !t.total) {
        em.el('emStatsContent', document).innerHTML = "no results found!";
      } else {
        for(var i=0;i<t.total;i++) data.push({
          date:parseInt(t.data[i].date),
          ball:t.data[i].ball.match(/\d+/g),
          star:t.data[i].star.match(/\d+/g)
        });
        for(var i=1;i<=50;i++)
          em.stats.data.ball.push(em.stats.crunch('ball', i, data));
        for(var i=1;i<=9;i++)
          em.stats.data.star.push(em.stats.crunch('star', i, data));
        em.stats.data.ball.sort(em.stats[((['sortN','sortV'])[em.el('emSort', document).selectedIndex])]);
        em.stats.data.star.sort(em.stats[((['sortN','sortV'])[em.el('emSort', document).selectedIndex])]);
      }
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug0:'); }
  },
  changeDateSkip:false,
  changeMode:function(m,str){
    var ms = (!m?'ball':'star');
    try {
      document.getElementById("emStatsDescription").innerHTML = '';
      if (!em.stats.changeModeSkip) { em.stats.changeModeSkip = true; return; }
      if (!em.el('emYear2004', document)) { return; }
      document.title = em.addon().name+' - Statistics for '+str;
      em.stats.load();
      var c = em.clean('emStatsContent', document);
      for(var i=0;i<em.stats.data[ms].length;i++) {
        var s = em.elc('span', document), cr = em.stats.data[ms][i];
        em.attr(s, 'class', 'sparky');
        em.attr(s, 'onmouseover', 'document.getElementById("emStatsDescription").innerHTML = "<img src=\'chrome://euromillions/skin/n/'+(m?'e':'')+(cr[0]<10?'0':'')+cr[0]+'.'+'gif\' style=\'width:17px;height:17px;margin-right:5px;\' align=\'top\'/>: '+cr[2]+' times in '+cr[3]+' draws, '+cr[1]+' consecutive.'+'"');
        s.innerHTML = cr[3]?cr.slice(1).join(','):'0,0,1';
        var img = em.elc('img', document);
        em.attr(img, 'style', 'width:17px;height:17px;margin-right:5px;');
        em.attr(img, 'src', 'chrome://euromillions/skin/n/'+(m?'e':'')+(cr[0]<10?'0':'')+cr[0]+'.'+'gif');
        em.add(c, img);
        em.add(c, s);
        em.add(c, em.elc('br', document));
      }
      $('.sparky').sparkline('html', {
        type:'bullet',
        targetColor:'green',
        performanceColor:'blue',
        fillColor:false,
        width:'350px',
        height:'auto'
      });
    } catch(e) { if (em.DEBUG) em.alert(e, 'emBug1:'); }
  },
  crunch:function(s,i,d){
    var a = 0;
    var b = 0;
    var c = 0;
    var cl = -2;
    for(var j=0;j<d.length;j++) {
      if (!em.el('emYear'+((new Date(d[j]['date'])).getFullYear()), document).checked) continue;
      b++;
      if (d[j][s].indexOf(i+'')!=-1) {
        a++;
        if (cl==(j-1))
          c++;
        cl = j;
      }
    }
    return [i, c, a, b];
  },
  sortN:function(a, b) { return a[0] - b[0]; },
  sortV:function(a, b) { return b[2] - a[2]; },
  changeSort:function(){
    em.stats.changeMode(em.el('emMode', document).selectedIndex, em.el('emMode', document).selectedItem?em.el('emMode', document).selectedItem.getAttribute('label'):'??');
  }
};